/* eslint-disable max-len */
import { singular } from 'pluralize'
import * as R from 'ramda'

import { Document, Entity, InfoRegistry, SumRegistry } from '../../../../../builders'
import { EntityWideGenerationArgs } from '../../../../../args'
import { getKeyField } from '../../../../../metaUtils'
import { camelSingular, pascalSingular } from '../../../../../../utils/cases'
import { generatedWarning, pad } from '../../../../../utils'

const arrToStr = (val: any) => R.trim(pad(1)(JSON.stringify(val, undefined, '  ').replaceAll('"', '\'')))
const getStrNames = R.compose(arrToStr, R.map(R.path(['name'])))

const autogeneratedStringId = (entity: Entity) =>
  getKeyField(entity).autoGenerated && getKeyField(entity).type === 'string'

export const configTmpl = ({
  entity,
  options,
  entities,
}: EntityWideGenerationArgs,
  allSumRegistries: Map<string, SumRegistry>,
  allInfoRegistries: Map<string, InfoRegistry>,
) => {
  const forbiddenForUserFields = entity.fields.filter(
    (f) => !f.updatableByUser && f.name !== 'search'
  )

  const searchableFields = entity.fields.filter((f) => f.searchable)
  const dateFields = searchableFields.filter((f) =>
    ['date', 'datetime'].includes(f.type)
  )
  const notDateFields = searchableFields.filter(
    (f) => !['date', 'datetime'].includes(f.type)
  )

  const isSharded = entity.sharded
  const shardUniqKeys = entity.fields.filter(f => f.sharded).map(f => f.name)
  const isDocument = entity.type === 'document'
  const isInfoRegistry = entity.type === 'infoRegistry'

  const isClearFromDB = entity.clearDBAfter.length > 0;

  let configType = 'ServiceConfig'
  if (isSharded) {
    configType = 'ServiceShardConfig'
  }
  if (isDocument) {
    configType = 'DocumentConfig'
    if (isSharded) {
      configType = 'DocumentShardConfig'
    }
  } else if (isInfoRegistry) {
    configType = 'InfoRegistryConfig'
    if (isSharded) {
      configType = 'InfoRegistryShardConfig'
    }
  }

  let docRegistries: Array<SumRegistry | InfoRegistry> = [];
  if (isDocument) {
    const document = entity as Document;

    docRegistries = document.registries.map((r) => {
      const sumRegistry = allSumRegistries.get(r)

      if (sumRegistry) {
        return sumRegistry
      }

      const infoRegistry = allInfoRegistries.get(r)

      if (!infoRegistry) {
        throw new Error(`There is no "${r}" registry`)
      }

      return infoRegistry
    })

    if (singular(entity.name) !== camelSingular(entity.name)) {
      console.log(`WARNING: need rename registrarTypeId: ${singular(entity.name)} entityTypeId: ${camelSingular(entity.name)}`)
    }
  }

  const registrarDependedRegistries = docRegistries.filter((r) => r.registrarDepended);
  const externalSearchDeps = registrarDependedRegistries.filter(r => r.externalSearchName).map((r) => [singular(r.name), singular(r.externalSearchName as string)]);

  // const externalSearchEntity = entities.find(e => e.name === entity.externalSearchName)

  return `/* eslint-disable quote-props,comma-dangle,@typescript-eslint/ban-types */
import Entity from '../../../types/Entity';
import {${configType}} from '../types';
${options.skipWarningThisIsGenerated ? '' : `
// ${generatedWarning}`}

const config: ${configType} = {
  idType: '${getKeyField(entity).type}',
  autogeneratedStringId: ${autogeneratedStringId(entity)},
  auditable: ${entity.auditable},
  withSearch: ${!!entity.fields.find((f) => f.name === 'search')},
  externalSearch: ${entity.externalSearch},
  sharded: ${isSharded},
  dateFields: ${getStrNames(dateFields)},
  otherFields: ${getStrNames(notDateFields)},
  forbiddenForUserFields: ${getStrNames(forbiddenForUserFields)},
  entityTypeId: Entity.${pascalSingular(entity.name)},${isDocument ? `
  registries: ${arrToStr(entity.registries.map((registry) => singular(registry)))},
  registrarDependedRegistries: ${arrToStr(registrarDependedRegistries.map((r) => singular(r.name)))},`
    : ''}${externalSearchDeps.length > 0 ? `
  externalSearchDeps: {
${externalSearchDeps.map(([key, val]) => `'${key}': '${val}',`).map(pad(2)).join('\n')}
  },` : ''}${isInfoRegistry ? `
  period: '${entity.period}',` : ''}${isSharded ? `
  uniqKeys: ${arrToStr(shardUniqKeys)},` : ''}${isClearFromDB ? `
  clearDBAfter: ${arrToStr(entity.clearDBAfter)},` : ''}
};

export default config;
`;
}
